<?php
/**
 * ProductDraft
 *
 * PHP version 5
 *
 * @category Class
 * @package  Ensi\PimClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */

/**
 * Ensi PIM.
 *
 * PIM
 *
 * The version of the OpenAPI document: 1.0.0
 * 
 * Generated by: https://openapi-generator.tech
 * OpenAPI Generator version: 4.3.1
 */

/**
 * NOTE: This class is auto generated by OpenAPI Generator (https://openapi-generator.tech).
 * https://openapi-generator.tech
 * Do not edit the class manually.
 */

namespace Ensi\PimClient\Dto;

use \ArrayAccess;
use \Ensi\PimClient\ObjectSerializer;

/**
 * ProductDraft Class Doc Comment
 *
 * @category Class
 * @package  Ensi\PimClient
 * @author   OpenAPI Generator team
 * @link     https://openapi-generator.tech
 */
class ProductDraft implements ModelInterface, ArrayAccess
{
    const DISCRIMINATOR = null;

    /**
      * The original name of the model.
      *
      * @var string
      */
    protected static $openAPIModelName = 'ProductDraft';

    /**
      * Array of property to type mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPITypes = [
        'id' => 'int',
        'tariffing_volume' => 'int',
        'created_at' => '\DateTime',
        'updated_at' => '\DateTime',
        'external_id' => 'string',
        'barcode' => 'string',
        'code' => 'string',
        'vendor_code' => 'string',
        'category_ids' => 'int[]',
        'brand_id' => 'int',
        'name' => 'string',
        'description' => 'string',
        'type' => 'int',
        'allow_publish' => 'bool',
        'weight' => 'float',
        'weight_gross' => 'float',
        'length' => 'float',
        'width' => 'float',
        'height' => 'float',
        'is_adult' => 'bool',
        'uom' => 'int',
        'order_step' => 'float',
        'order_minvol' => 'float',
        'picking_weight_deviation' => 'float',
        'status_id' => 'int',
        'status_comment' => 'string',
        'brand' => '\Ensi\PimClient\Dto\Brand',
        'categories' => '\Ensi\PimClient\Dto\Category[]',
        'category_product_links' => '\Ensi\PimClient\Dto\CategoryProductLink[]',
        'images' => '\Ensi\PimClient\Dto\ProductImage[]',
        'attributes' => '\Ensi\PimClient\Dto\ProductAttributeValue[]',
        'product_groups' => '\Ensi\PimClient\Dto\ProductGroup[]',
        'no_filled_required_attributes' => 'bool'
    ];

    /**
      * Array of property to format mappings. Used for (de)serialization
      *
      * @var string[]
      */
    protected static $openAPIFormats = [
        'id' => null,
        'tariffing_volume' => null,
        'created_at' => 'date-time',
        'updated_at' => 'date-time',
        'external_id' => null,
        'barcode' => null,
        'code' => null,
        'vendor_code' => null,
        'category_ids' => null,
        'brand_id' => null,
        'name' => null,
        'description' => null,
        'type' => null,
        'allow_publish' => null,
        'weight' => null,
        'weight_gross' => null,
        'length' => null,
        'width' => null,
        'height' => null,
        'is_adult' => null,
        'uom' => null,
        'order_step' => null,
        'order_minvol' => null,
        'picking_weight_deviation' => null,
        'status_id' => null,
        'status_comment' => null,
        'brand' => null,
        'categories' => null,
        'category_product_links' => null,
        'images' => null,
        'attributes' => null,
        'product_groups' => null,
        'no_filled_required_attributes' => null
    ];

    /**
      * Array of nullable properties. Used for (de)serialization
      *
      * @var boolean[]
      */
    protected static $openAPINullables = [
        'id' => false,
        'tariffing_volume' => true,
        'created_at' => false,
        'updated_at' => false,
        'external_id' => true,
        'barcode' => true,
        'code' => true,
        'vendor_code' => false,
        'category_ids' => false,
        'brand_id' => true,
        'name' => false,
        'description' => true,
        'type' => false,
        'allow_publish' => false,
        'weight' => true,
        'weight_gross' => true,
        'length' => true,
        'width' => true,
        'height' => true,
        'is_adult' => true,
        'uom' => true,
        'order_step' => true,
        'order_minvol' => true,
        'picking_weight_deviation' => true,
        'status_id' => true,
        'status_comment' => true,
        'brand' => false,
        'categories' => false,
        'category_product_links' => false,
        'images' => false,
        'attributes' => false,
        'product_groups' => false,
        'no_filled_required_attributes' => false
    ];

    /**
      * If a nullable field gets set to null, insert it here
      *
      * @var boolean[]
      */
    protected $openAPINullablesSetToNull = [];

    /**
     * Array of property to type mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPITypes()
    {
        return self::$openAPITypes;
    }

    /**
     * Array of property to format mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPIFormats()
    {
        return self::$openAPIFormats;
    }

        /**
     * Array of property to nullable mappings. Used for (de)serialization
     *
     * @return array
     */
    public static function openAPINullables()
    {
        return self::$openAPINullables;
    }

    /**
     * Array of nullable field names deliberately set to null
     *
     * @return array
     */
    public function getOpenAPINullablesSetToNull()
    {
        return $this->openAPINullablesSetToNull;
    }

    public function setOpenAPINullablesSetToNull($nullablesSetToNull)
    {
        $this->openAPINullablesSetToNull=$nullablesSetToNull;
        return $this;
    }

    /**
     * Checks if a property is nullable
     *
     * @return bool
     */
    public static function isNullable(string $property): bool
    {
        if (isset(self::openAPINullables()[$property])) {
            return self::openAPINullables()[$property];
        }

        return false;
    }

    /**
     * Checks if a nullable property is set to null.
     *
     * @return bool
     */
    public function isNullableSetToNull(string $property): bool
    {
        if (in_array($property, $this->getOpenAPINullablesSetToNull())) {
            return true;
        }
        return false;
    }

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @var string[]
     */
    protected static $attributeMap = [
        'id' => 'id',
        'tariffing_volume' => 'tariffing_volume',
        'created_at' => 'created_at',
        'updated_at' => 'updated_at',
        'external_id' => 'external_id',
        'barcode' => 'barcode',
        'code' => 'code',
        'vendor_code' => 'vendor_code',
        'category_ids' => 'category_ids',
        'brand_id' => 'brand_id',
        'name' => 'name',
        'description' => 'description',
        'type' => 'type',
        'allow_publish' => 'allow_publish',
        'weight' => 'weight',
        'weight_gross' => 'weight_gross',
        'length' => 'length',
        'width' => 'width',
        'height' => 'height',
        'is_adult' => 'is_adult',
        'uom' => 'uom',
        'order_step' => 'order_step',
        'order_minvol' => 'order_minvol',
        'picking_weight_deviation' => 'picking_weight_deviation',
        'status_id' => 'status_id',
        'status_comment' => 'status_comment',
        'brand' => 'brand',
        'categories' => 'categories',
        'category_product_links' => 'category_product_links',
        'images' => 'images',
        'attributes' => 'attributes',
        'product_groups' => 'product_groups',
        'no_filled_required_attributes' => 'no_filled_required_attributes'
    ];

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @var string[]
     */
    protected static $setters = [
        'id' => 'setId',
        'tariffing_volume' => 'setTariffingVolume',
        'created_at' => 'setCreatedAt',
        'updated_at' => 'setUpdatedAt',
        'external_id' => 'setExternalId',
        'barcode' => 'setBarcode',
        'code' => 'setCode',
        'vendor_code' => 'setVendorCode',
        'category_ids' => 'setCategoryIds',
        'brand_id' => 'setBrandId',
        'name' => 'setName',
        'description' => 'setDescription',
        'type' => 'setType',
        'allow_publish' => 'setAllowPublish',
        'weight' => 'setWeight',
        'weight_gross' => 'setWeightGross',
        'length' => 'setLength',
        'width' => 'setWidth',
        'height' => 'setHeight',
        'is_adult' => 'setIsAdult',
        'uom' => 'setUom',
        'order_step' => 'setOrderStep',
        'order_minvol' => 'setOrderMinvol',
        'picking_weight_deviation' => 'setPickingWeightDeviation',
        'status_id' => 'setStatusId',
        'status_comment' => 'setStatusComment',
        'brand' => 'setBrand',
        'categories' => 'setCategories',
        'category_product_links' => 'setCategoryProductLinks',
        'images' => 'setImages',
        'attributes' => 'setAttributes',
        'product_groups' => 'setProductGroups',
        'no_filled_required_attributes' => 'setNoFilledRequiredAttributes'
    ];

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @var string[]
     */
    protected static $getters = [
        'id' => 'getId',
        'tariffing_volume' => 'getTariffingVolume',
        'created_at' => 'getCreatedAt',
        'updated_at' => 'getUpdatedAt',
        'external_id' => 'getExternalId',
        'barcode' => 'getBarcode',
        'code' => 'getCode',
        'vendor_code' => 'getVendorCode',
        'category_ids' => 'getCategoryIds',
        'brand_id' => 'getBrandId',
        'name' => 'getName',
        'description' => 'getDescription',
        'type' => 'getType',
        'allow_publish' => 'getAllowPublish',
        'weight' => 'getWeight',
        'weight_gross' => 'getWeightGross',
        'length' => 'getLength',
        'width' => 'getWidth',
        'height' => 'getHeight',
        'is_adult' => 'getIsAdult',
        'uom' => 'getUom',
        'order_step' => 'getOrderStep',
        'order_minvol' => 'getOrderMinvol',
        'picking_weight_deviation' => 'getPickingWeightDeviation',
        'status_id' => 'getStatusId',
        'status_comment' => 'getStatusComment',
        'brand' => 'getBrand',
        'categories' => 'getCategories',
        'category_product_links' => 'getCategoryProductLinks',
        'images' => 'getImages',
        'attributes' => 'getAttributes',
        'product_groups' => 'getProductGroups',
        'no_filled_required_attributes' => 'getNoFilledRequiredAttributes'
    ];

    /**
     * Array of attributes where the key is the local name,
     * and the value is the original name
     *
     * @return array
     */
    public static function attributeMap()
    {
        return self::$attributeMap;
    }

    /**
     * Array of attributes to setter functions (for deserialization of responses)
     *
     * @return array
     */
    public static function setters()
    {
        return self::$setters;
    }

    /**
     * Array of attributes to getter functions (for serialization of requests)
     *
     * @return array
     */
    public static function getters()
    {
        return self::$getters;
    }

    /**
     * The original name of the model.
     *
     * @return string
     */
    public function getModelName()
    {
        return self::$openAPIModelName;
    }

    

    

    /**
     * Associative array for storing property values
     *
     * @var mixed[]
     */
    protected $container = [];

    /**
     * Constructor
     *
     * @param mixed[] $data Associated array of property values
     *                      initializing the model
     */
    public function __construct(array $data = null)
    {
        $this->setIfExists('id', $data, null);
        $this->setIfExists('tariffing_volume', $data, null);
        $this->setIfExists('created_at', $data, null);
        $this->setIfExists('updated_at', $data, null);
        $this->setIfExists('external_id', $data, null);
        $this->setIfExists('barcode', $data, null);
        $this->setIfExists('code', $data, null);
        $this->setIfExists('vendor_code', $data, null);
        $this->setIfExists('category_ids', $data, null);
        $this->setIfExists('brand_id', $data, null);
        $this->setIfExists('name', $data, null);
        $this->setIfExists('description', $data, null);
        $this->setIfExists('type', $data, null);
        $this->setIfExists('allow_publish', $data, null);
        $this->setIfExists('weight', $data, null);
        $this->setIfExists('weight_gross', $data, null);
        $this->setIfExists('length', $data, null);
        $this->setIfExists('width', $data, null);
        $this->setIfExists('height', $data, null);
        $this->setIfExists('is_adult', $data, null);
        $this->setIfExists('uom', $data, null);
        $this->setIfExists('order_step', $data, null);
        $this->setIfExists('order_minvol', $data, null);
        $this->setIfExists('picking_weight_deviation', $data, null);
        $this->setIfExists('status_id', $data, null);
        $this->setIfExists('status_comment', $data, null);
        $this->setIfExists('brand', $data, null);
        $this->setIfExists('categories', $data, null);
        $this->setIfExists('category_product_links', $data, null);
        $this->setIfExists('images', $data, null);
        $this->setIfExists('attributes', $data, null);
        $this->setIfExists('product_groups', $data, null);
        $this->setIfExists('no_filled_required_attributes', $data, null);
    }

    public function setIfExists(string $variableName, $fields, $defaultValue)
    {
        if (is_array($fields) && array_key_exists($variableName, $fields) && is_null($fields[$variableName]) && self::isNullable($variableName)) {
            array_push($this->openAPINullablesSetToNull, $variableName);
        }

        $this->container[$variableName] = isset($fields[$variableName]) ? $fields[$variableName] : $defaultValue;

        return $this;
    }

    /**
     * Show all the invalid properties with reasons.
     *
     * @return array invalid properties with reasons
     */
    public function listInvalidProperties()
    {
        $invalidProperties = [];

        if ($this->container['id'] === null) {
            $invalidProperties[] = "'id' can't be null";
        }
        if ($this->container['tariffing_volume'] === null) {
            $invalidProperties[] = "'tariffing_volume' can't be null";
        }
        if ($this->container['created_at'] === null) {
            $invalidProperties[] = "'created_at' can't be null";
        }
        if ($this->container['updated_at'] === null) {
            $invalidProperties[] = "'updated_at' can't be null";
        }
        return $invalidProperties;
    }

    /**
     * Validate all the properties in the model
     * return true if all passed
     *
     * @return bool True if all properties are valid
     */
    public function valid()
    {
        return count($this->listInvalidProperties()) === 0;
    }


    /**
     * Gets id
     *
     * @return int
     */
    public function getId()
    {
        return $this->container['id'];
    }

    /**
     * Sets id
     *
     * @param int $id id
     *
     * @return $this
     */
    public function setId($id)
    {


        /*if (is_null($id)) {
            throw new \InvalidArgumentException('non-nullable id cannot be null');
        }*/
        $this->container['id'] = $id;

        return $this;
    }

    /**
     * Gets tariffing_volume
     *
     * @return int|null
     */
    public function getTariffingVolume()
    {
        return $this->container['tariffing_volume'];
    }

    /**
     * Sets tariffing_volume
     *
     * @param int|null $tariffing_volume Unit of tariffication from ProductTariffingVolumeEnum
     *
     * @return $this
     */
    public function setTariffingVolume($tariffing_volume)
    {

        if (is_null($tariffing_volume)) {
            array_push($this->openAPINullablesSetToNull, 'tariffing_volume');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('tariffing_volume', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['tariffing_volume'] = $tariffing_volume;

        return $this;
    }

    /**
     * Gets created_at
     *
     * @return \DateTime
     */
    public function getCreatedAt()
    {
        return $this->container['created_at'];
    }

    /**
     * Sets created_at
     *
     * @param \DateTime $created_at Create time
     *
     * @return $this
     */
    public function setCreatedAt($created_at)
    {


        /*if (is_null($created_at)) {
            throw new \InvalidArgumentException('non-nullable created_at cannot be null');
        }*/
        $this->container['created_at'] = $created_at;

        return $this;
    }

    /**
     * Gets updated_at
     *
     * @return \DateTime
     */
    public function getUpdatedAt()
    {
        return $this->container['updated_at'];
    }

    /**
     * Sets updated_at
     *
     * @param \DateTime $updated_at Update time
     *
     * @return $this
     */
    public function setUpdatedAt($updated_at)
    {


        /*if (is_null($updated_at)) {
            throw new \InvalidArgumentException('non-nullable updated_at cannot be null');
        }*/
        $this->container['updated_at'] = $updated_at;

        return $this;
    }

    /**
     * Gets external_id
     *
     * @return string|null
     */
    public function getExternalId()
    {
        return $this->container['external_id'];
    }

    /**
     * Sets external_id
     *
     * @param string|null $external_id external_id
     *
     * @return $this
     */
    public function setExternalId($external_id)
    {

        if (is_null($external_id)) {
            array_push($this->openAPINullablesSetToNull, 'external_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('external_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['external_id'] = $external_id;

        return $this;
    }

    /**
     * Gets barcode
     *
     * @return string|null
     */
    public function getBarcode()
    {
        return $this->container['barcode'];
    }

    /**
     * Sets barcode
     *
     * @param string|null $barcode EAN
     *
     * @return $this
     */
    public function setBarcode($barcode)
    {

        if (is_null($barcode)) {
            array_push($this->openAPINullablesSetToNull, 'barcode');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('barcode', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['barcode'] = $barcode;

        return $this;
    }

    /**
     * Gets code
     *
     * @return string|null
     */
    public function getCode()
    {
        return $this->container['code'];
    }

    /**
     * Sets code
     *
     * @param string|null $code Code to use in URL
     *
     * @return $this
     */
    public function setCode($code)
    {

        if (is_null($code)) {
            array_push($this->openAPINullablesSetToNull, 'code');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('code', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['code'] = $code;

        return $this;
    }

    /**
     * Gets vendor_code
     *
     * @return string|null
     */
    public function getVendorCode()
    {
        return $this->container['vendor_code'];
    }

    /**
     * Sets vendor_code
     *
     * @param string|null $vendor_code Article
     *
     * @return $this
     */
    public function setVendorCode($vendor_code)
    {


        /*if (is_null($vendor_code)) {
            throw new \InvalidArgumentException('non-nullable vendor_code cannot be null');
        }*/
        $this->container['vendor_code'] = $vendor_code;

        return $this;
    }

    /**
     * Gets category_ids
     *
     * @return int[]|null
     */
    public function getCategoryIds()
    {
        return $this->container['category_ids'];
    }

    /**
     * Sets category_ids
     *
     * @param int[]|null $category_ids category_ids
     *
     * @return $this
     */
    public function setCategoryIds($category_ids)
    {


        /*if (is_null($category_ids)) {
            throw new \InvalidArgumentException('non-nullable category_ids cannot be null');
        }*/
        $this->container['category_ids'] = $category_ids;

        return $this;
    }

    /**
     * Gets brand_id
     *
     * @return int|null
     */
    public function getBrandId()
    {
        return $this->container['brand_id'];
    }

    /**
     * Sets brand_id
     *
     * @param int|null $brand_id brand_id
     *
     * @return $this
     */
    public function setBrandId($brand_id)
    {

        if (is_null($brand_id)) {
            array_push($this->openAPINullablesSetToNull, 'brand_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('brand_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['brand_id'] = $brand_id;

        return $this;
    }

    /**
     * Gets name
     *
     * @return string|null
     */
    public function getName()
    {
        return $this->container['name'];
    }

    /**
     * Sets name
     *
     * @param string|null $name name
     *
     * @return $this
     */
    public function setName($name)
    {


        /*if (is_null($name)) {
            throw new \InvalidArgumentException('non-nullable name cannot be null');
        }*/
        $this->container['name'] = $name;

        return $this;
    }

    /**
     * Gets description
     *
     * @return string|null
     */
    public function getDescription()
    {
        return $this->container['description'];
    }

    /**
     * Sets description
     *
     * @param string|null $description description
     *
     * @return $this
     */
    public function setDescription($description)
    {

        if (is_null($description)) {
            array_push($this->openAPINullablesSetToNull, 'description');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('description', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['description'] = $description;

        return $this;
    }

    /**
     * Gets type
     *
     * @return int|null
     */
    public function getType()
    {
        return $this->container['type'];
    }

    /**
     * Sets type
     *
     * @param int|null $type Product type from ProductTypeEnum
     *
     * @return $this
     */
    public function setType($type)
    {


        /*if (is_null($type)) {
            throw new \InvalidArgumentException('non-nullable type cannot be null');
        }*/
        $this->container['type'] = $type;

        return $this;
    }

    /**
     * Gets allow_publish
     *
     * @return bool|null
     */
    public function getAllowPublish()
    {
        return $this->container['allow_publish'];
    }

    /**
     * Sets allow_publish
     *
     * @param bool|null $allow_publish allow_publish
     *
     * @return $this
     */
    public function setAllowPublish($allow_publish)
    {


        /*if (is_null($allow_publish)) {
            throw new \InvalidArgumentException('non-nullable allow_publish cannot be null');
        }*/
        $this->container['allow_publish'] = $allow_publish;

        return $this;
    }

    /**
     * Gets weight
     *
     * @return float|null
     */
    public function getWeight()
    {
        return $this->container['weight'];
    }

    /**
     * Sets weight
     *
     * @param float|null $weight Net weight in kg
     *
     * @return $this
     */
    public function setWeight($weight)
    {

        if (is_null($weight)) {
            array_push($this->openAPINullablesSetToNull, 'weight');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('weight', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['weight'] = $weight;

        return $this;
    }

    /**
     * Gets weight_gross
     *
     * @return float|null
     */
    public function getWeightGross()
    {
        return $this->container['weight_gross'];
    }

    /**
     * Sets weight_gross
     *
     * @param float|null $weight_gross Gross weight in kg
     *
     * @return $this
     */
    public function setWeightGross($weight_gross)
    {

        if (is_null($weight_gross)) {
            array_push($this->openAPINullablesSetToNull, 'weight_gross');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('weight_gross', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['weight_gross'] = $weight_gross;

        return $this;
    }

    /**
     * Gets length
     *
     * @return float|null
     */
    public function getLength()
    {
        return $this->container['length'];
    }

    /**
     * Sets length
     *
     * @param float|null $length Length in mm
     *
     * @return $this
     */
    public function setLength($length)
    {

        if (is_null($length)) {
            array_push($this->openAPINullablesSetToNull, 'length');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('length', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['length'] = $length;

        return $this;
    }

    /**
     * Gets width
     *
     * @return float|null
     */
    public function getWidth()
    {
        return $this->container['width'];
    }

    /**
     * Sets width
     *
     * @param float|null $width Width in mm
     *
     * @return $this
     */
    public function setWidth($width)
    {

        if (is_null($width)) {
            array_push($this->openAPINullablesSetToNull, 'width');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('width', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['width'] = $width;

        return $this;
    }

    /**
     * Gets height
     *
     * @return float|null
     */
    public function getHeight()
    {
        return $this->container['height'];
    }

    /**
     * Sets height
     *
     * @param float|null $height Height in mm
     *
     * @return $this
     */
    public function setHeight($height)
    {

        if (is_null($height)) {
            array_push($this->openAPINullablesSetToNull, 'height');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('height', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['height'] = $height;

        return $this;
    }

    /**
     * Gets is_adult
     *
     * @return bool|null
     */
    public function getIsAdult()
    {
        return $this->container['is_adult'];
    }

    /**
     * Sets is_adult
     *
     * @param bool|null $is_adult Is product 18+
     *
     * @return $this
     */
    public function setIsAdult($is_adult)
    {

        if (is_null($is_adult)) {
            array_push($this->openAPINullablesSetToNull, 'is_adult');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('is_adult', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['is_adult'] = $is_adult;

        return $this;
    }

    /**
     * Gets uom
     *
     * @return int|null
     */
    public function getUom()
    {
        return $this->container['uom'];
    }

    /**
     * Sets uom
     *
     * @param int|null $uom Unit of measurement from ProductUomEnum
     *
     * @return $this
     */
    public function setUom($uom)
    {

        if (is_null($uom)) {
            array_push($this->openAPINullablesSetToNull, 'uom');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('uom', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['uom'] = $uom;

        return $this;
    }

    /**
     * Gets order_step
     *
     * @return float|null
     */
    public function getOrderStep()
    {
        return $this->container['order_step'];
    }

    /**
     * Sets order_step
     *
     * @param float|null $order_step order_step
     *
     * @return $this
     */
    public function setOrderStep($order_step)
    {

        if (is_null($order_step)) {
            array_push($this->openAPINullablesSetToNull, 'order_step');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('order_step', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['order_step'] = $order_step;

        return $this;
    }

    /**
     * Gets order_minvol
     *
     * @return float|null
     */
    public function getOrderMinvol()
    {
        return $this->container['order_minvol'];
    }

    /**
     * Sets order_minvol
     *
     * @param float|null $order_minvol Minimum quantity for order
     *
     * @return $this
     */
    public function setOrderMinvol($order_minvol)
    {

        if (is_null($order_minvol)) {
            array_push($this->openAPINullablesSetToNull, 'order_minvol');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('order_minvol', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['order_minvol'] = $order_minvol;

        return $this;
    }

    /**
     * Gets picking_weight_deviation
     *
     * @return float|null
     */
    public function getPickingWeightDeviation()
    {
        return $this->container['picking_weight_deviation'];
    }

    /**
     * Sets picking_weight_deviation
     *
     * @param float|null $picking_weight_deviation Weight deviation limit in percent
     *
     * @return $this
     */
    public function setPickingWeightDeviation($picking_weight_deviation)
    {

        if (is_null($picking_weight_deviation)) {
            array_push($this->openAPINullablesSetToNull, 'picking_weight_deviation');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('picking_weight_deviation', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['picking_weight_deviation'] = $picking_weight_deviation;

        return $this;
    }

    /**
     * Gets status_id
     *
     * @return int|null
     */
    public function getStatusId()
    {
        return $this->container['status_id'];
    }

    /**
     * Sets status_id
     *
     * @param int|null $status_id Status ID from ProductStatusSetting object
     *
     * @return $this
     */
    public function setStatusId($status_id)
    {

        if (is_null($status_id)) {
            array_push($this->openAPINullablesSetToNull, 'status_id');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('status_id', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['status_id'] = $status_id;

        return $this;
    }

    /**
     * Gets status_comment
     *
     * @return string|null
     */
    public function getStatusComment()
    {
        return $this->container['status_comment'];
    }

    /**
     * Sets status_comment
     *
     * @param string|null $status_comment status_comment
     *
     * @return $this
     */
    public function setStatusComment($status_comment)
    {

        if (is_null($status_comment)) {
            array_push($this->openAPINullablesSetToNull, 'status_comment');
        } else {
            $nullablesSetToNull = $this->getOpenAPINullablesSetToNull();
            $index = array_search('status_comment', $nullablesSetToNull);
            if ($index !== FALSE) {
                unset($nullablesSetToNull[$index]);
                $this->setOpenAPINullablesSetToNull($nullablesSetToNull);
            }
        }

        $this->container['status_comment'] = $status_comment;

        return $this;
    }

    /**
     * Gets brand
     *
     * @return \Ensi\PimClient\Dto\Brand|null
     */
    public function getBrand()
    {
        return $this->container['brand'];
    }

    /**
     * Sets brand
     *
     * @param \Ensi\PimClient\Dto\Brand|null $brand brand
     *
     * @return $this
     */
    public function setBrand($brand)
    {


        /*if (is_null($brand)) {
            throw new \InvalidArgumentException('non-nullable brand cannot be null');
        }*/
        $this->container['brand'] = $brand;

        return $this;
    }

    /**
     * Gets categories
     *
     * @return \Ensi\PimClient\Dto\Category[]|null
     */
    public function getCategories()
    {
        return $this->container['categories'];
    }

    /**
     * Sets categories
     *
     * @param \Ensi\PimClient\Dto\Category[]|null $categories categories
     *
     * @return $this
     */
    public function setCategories($categories)
    {


        /*if (is_null($categories)) {
            throw new \InvalidArgumentException('non-nullable categories cannot be null');
        }*/
        $this->container['categories'] = $categories;

        return $this;
    }

    /**
     * Gets category_product_links
     *
     * @return \Ensi\PimClient\Dto\CategoryProductLink[]|null
     */
    public function getCategoryProductLinks()
    {
        return $this->container['category_product_links'];
    }

    /**
     * Sets category_product_links
     *
     * @param \Ensi\PimClient\Dto\CategoryProductLink[]|null $category_product_links category_product_links
     *
     * @return $this
     */
    public function setCategoryProductLinks($category_product_links)
    {


        /*if (is_null($category_product_links)) {
            throw new \InvalidArgumentException('non-nullable category_product_links cannot be null');
        }*/
        $this->container['category_product_links'] = $category_product_links;

        return $this;
    }

    /**
     * Gets images
     *
     * @return \Ensi\PimClient\Dto\ProductImage[]|null
     */
    public function getImages()
    {
        return $this->container['images'];
    }

    /**
     * Sets images
     *
     * @param \Ensi\PimClient\Dto\ProductImage[]|null $images images
     *
     * @return $this
     */
    public function setImages($images)
    {


        /*if (is_null($images)) {
            throw new \InvalidArgumentException('non-nullable images cannot be null');
        }*/
        $this->container['images'] = $images;

        return $this;
    }

    /**
     * Gets attributes
     *
     * @return \Ensi\PimClient\Dto\ProductAttributeValue[]|null
     */
    public function getAttributes()
    {
        return $this->container['attributes'];
    }

    /**
     * Sets attributes
     *
     * @param \Ensi\PimClient\Dto\ProductAttributeValue[]|null $attributes attributes
     *
     * @return $this
     */
    public function setAttributes($attributes)
    {


        /*if (is_null($attributes)) {
            throw new \InvalidArgumentException('non-nullable attributes cannot be null');
        }*/
        $this->container['attributes'] = $attributes;

        return $this;
    }

    /**
     * Gets product_groups
     *
     * @return \Ensi\PimClient\Dto\ProductGroup[]|null
     */
    public function getProductGroups()
    {
        return $this->container['product_groups'];
    }

    /**
     * Sets product_groups
     *
     * @param \Ensi\PimClient\Dto\ProductGroup[]|null $product_groups product_groups
     *
     * @return $this
     */
    public function setProductGroups($product_groups)
    {


        /*if (is_null($product_groups)) {
            throw new \InvalidArgumentException('non-nullable product_groups cannot be null');
        }*/
        $this->container['product_groups'] = $product_groups;

        return $this;
    }

    /**
     * Gets no_filled_required_attributes
     *
     * @return bool|null
     */
    public function getNoFilledRequiredAttributes()
    {
        return $this->container['no_filled_required_attributes'];
    }

    /**
     * Sets no_filled_required_attributes
     *
     * @param bool|null $no_filled_required_attributes Product has not filled required attributes
     *
     * @return $this
     */
    public function setNoFilledRequiredAttributes($no_filled_required_attributes)
    {


        /*if (is_null($no_filled_required_attributes)) {
            throw new \InvalidArgumentException('non-nullable no_filled_required_attributes cannot be null');
        }*/
        $this->container['no_filled_required_attributes'] = $no_filled_required_attributes;

        return $this;
    }
    /**
     * Returns true if offset exists. False otherwise.
     *
     * @param integer $offset Offset
     *
     * @return boolean
     */
    public function offsetExists($offset): bool
    {
        return isset($this->container[$offset]);
    }

    /**
     * Gets offset.
     *
     * @param integer $offset Offset
     *
     * @return mixed
     */
    public function offsetGet($offset): mixed
    {
        return isset($this->container[$offset]) ? $this->container[$offset] : null;
    }

    /**
     * Sets value based on offset.
     *
     * @param integer $offset Offset
     * @param mixed   $value  Value to be set
     *
     * @return void
     */
    public function offsetSet($offset, $value): void
    {
        if (is_null($offset)) {
            $this->container[] = $value;
        } else {
            $this->container[$offset] = $value;
        }
    }

    /**
     * Unsets offset.
     *
     * @param integer $offset Offset
     *
     * @return void
     */
    public function offsetUnset($offset): void
    {
        unset($this->container[$offset]);
    }

    /**
     * Gets the string presentation of the object
     *
     * @return string
     */
    public function __toString()
    {
        return json_encode(
            ObjectSerializer::sanitizeForSerialization($this),
            JSON_PRETTY_PRINT
        );
    }

    /**
     * Gets a header-safe presentation of the object
     *
     * @return string
     */
    public function toHeaderValue()
    {
        return json_encode(ObjectSerializer::sanitizeForSerialization($this));
    }

    /**
    * Convert object to array
    *
    * @return array
    */
    public function toArray()
    {
        return json_decode(json_encode(ObjectSerializer::sanitizeForSerialization($this)), true);
    }
}


